#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ShellCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ShellCFG> Fish_ShellCFG::msSingleton(nullptr);

int Fish_ShellCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ShellCFGData* Fish_ShellCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ShellCFGData>& Fish_ShellCFG::GetMapData()
{
	return mMapData;
}

void Fish_ShellCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ShellCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ShellCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mShellrate = element->IntAttribute("Shellrate");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* ShellItem = element->Attribute("ShellItem");
			std::vector<std::string> vecShellItem;
			boost::split(vecShellItem, ShellItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShellItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShellItem[i].c_str(), &temp))
				{
					data.mShellItem.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ShellCFG::Load()
{
	Load("../Config/Fish_ShellCFG.xml");
}

Fish_ShellCFG* Fish_ShellCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ShellCFG());
	}
	return msSingleton.get();
}
